#!/bin/sh

# work with udev for IBM SCSI tape device persistent naming support 
# Copyright (C) IBM Corporation, 2007

CWD="`pwd`"

SYSFS=/sys

read major_minor < $SYSFS$DEVPATH/dev
major=${major_minor%%:*}
minor=${major_minor##*:}

NAME=`echo $DEVPATH|sed -e 's/.*\/\([a-zA-Z]*\)[0-9n]*$/\1/'`

NONREWOFFSET=1023
PETRONONREWOFFSET=511
PETRONONRESVOFFSET=1023
CHANGEROFFSET=2047

#use the following if petro driver parameter is OFF (default value)
n=''
if [ $minor -gt  $NONREWOFFSET -a $minor -lt $CHANGEROFFSET ] ; then 
    n='n'
fi

#use the following (remove # marks in the lines below and add # marks in the above lines)
# if petro driver parameter is ON
#n=''
#if [ $minor -gt $PETRONONREWOFFSET -a $minor -lt $PETRONONRESVOFFSET ] ; then
#    n='n'
#elif [ $minor -gt $PETRONONRESVOFFSET -a $minor -lt $CHANGEROFFSET ] ; then
#    NAME='IBMtapenrsv'
#fi

# lin_tape does not have the IOCTL that scsi_id uses however it
# has a sysfs entry pointing to the generic device which does
# support that IOCTL

SYMLINKPATH="$SYSFS$DEVPATH/device/generic"
if [ ! -d  $SYMLINKPATH ] ; then
    exit 1
fi

cd $SYMLINKPATH
GDEVICEPATH="`pwd -P|sed -e '{ s/\/sys\(.*\)/\1/ }'`"
#use the following line if you want to use WWNNs for tape drives 
# and serial numbers for medium changers 
TAPE_ID="`/sbin/scsi_id -gus $GDEVICEPATH`"
#use the following (remove # mark in the line below and add # in the above line) 
# if you want to use serial number for tape drives and medium changers
#TAPE_ID="`/sbin/scsi_id -p 0x80 -gus $GDEVICEPATH`"

echo -n $TAPE_ID-$NAME$n

exit 0
